/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: interrupt.h 49 2012-09-06 04:41:53Z ertl-hiro $
 */

/*
 *		ߴǽ
 */

#ifndef TOPPERS_INTERRUPT_H
#define TOPPERS_INTERRUPT_H

/*
 *  ֹ˼ߥϥɥη
 */
typedef void	(*IINTHDR)(INTNO intno);

/*
 *  ߥӥ롼֥å
 */
typedef struct isr_initialization_block {
	ATR			isratr;			/* ߥӥ롼° */
	intptr_t	exinf;			/* ߥӥ롼γĥ */
	INTNO		intno;			/* ߥӥ롼Ͽֹ */
	QUEUE		*p_isr_queue;	/* Ͽߥӥ롼󥭥塼 */
	ISR			isr;			/* ߥӥ롼Ƭ */
	PRI			isrpri;			/* ߥӥ롼ͥ */
} ISRINIB;

/*
 *  ߥӥ롼֥å
 */
typedef struct isr_control_block {
	QUEUE		isr_queue;		/* ߥӥ롼ƽФ塼 */
	const ISRINIB *p_isrinib;	/* ֥åؤΥݥ */
} ISRCB;

/*
 *  ߥӥ롼󥭥塼Υꥢ
 */
extern QUEUE	isr_queue_table[];

/*
 *  ѤƤʤߥӥ롼֥åΥꥹ
 */
extern QUEUE	free_isrcb;

/*
 *  ߥӥ롼IDκ͡kernel_cfg.c
 */
extern const ID		tmax_isrid;

/*
 *  ߥӥ롼֥åΥꥢkernel_cfg.c
 */
extern ISRINIB	isrinib_table[];

/*
 *  ߥӥ롼֥åΥꥢkernel_cfg.c
 */
extern ISRCB	isrcb_table[];

/*
 *  ߥӥ롼ǽν
 */
extern void initialize_isr(void);

/*
 *  ߥӥ롼θƽФ
 */
extern void call_isr(QUEUE *p_isr_queue);

/*
 *  ߥϥɥ֥å
 */
typedef struct interrupt_handler_initialization_block {
	ATR			inhatr;			/* ߥϥɥ° */
	IINTHDR		inthdr;			/* ߥϥɥƬ */
} INHINIB;

/*
 *  ׵饤֥å
 */
typedef struct interrupt_request_initialization_block {
	ATR			intatr;			/* ° */
	PRI			intpri;			/* ͥ */
} INTINIB;

/*
 *  ߥϥɥ֥åΥꥢkernel_cfg.c
 */
extern INHINIB	inhinib_table[];

/*
 *  ׵饤֥åΥꥢkernel_cfg.c
 */
extern INTINIB	intinib_table[];

/*
 *  ֹ椫׵饤֥åФΥޥ
 */
#define get_intinib(intno)	(&(intinib_table[INDEX_INTNO(intno)]))

/*
 *  ߥϥɥֹ椫ߥϥɥ֥åФ
 *  ޥ
 */
#define get_inhinib(inhno)	(&(inhinib_table[INDEX_INHNO(inhno)]))

/*
 *  ߴǽν
 */
extern void	initialize_interrupt(void);

#endif /* TOPPERS_INTERRUPT_H */
